import type { InternetGatewayDevice } from '../upnp/device';
import type { Service } from '@achingbrain/ssdp';
export interface DiscoverGateway {
    gateway(): Promise<Service<InternetGatewayDevice>>;
    cancel(): Promise<void>;
}
export interface DiscoveryOptions {
    /**
     * Do not search the network for a gateway, use this instead
     */
    gateway?: string;
    /**
     * Rediscover gateway after this number of ms
     */
    timeout?: number;
    /**
     * Only search the network for this long
     */
    discoveryTimeout?: number;
}
export declare function discoverGateway(options?: DiscoveryOptions): () => DiscoverGateway;
//# sourceMappingURL=index.d.ts.map