import { Device } from './device.js';
import type { DiscoverGateway } from '../discovery/index.js';
import type { Client, MapPortOptions, UnmapPortOptions } from '../index.js';
export declare class UPNPClient implements Client {
    private closed;
    private readonly discoverGateway;
    private cancelGatewayDiscovery?;
    private readonly abortController;
    static createClient(discoverGateway: () => DiscoverGateway): UPNPClient;
    constructor(discoverGateway: () => DiscoverGateway);
    map(options: MapPortOptions): Promise<void>;
    unmap(options: UnmapPortOptions): Promise<void>;
    externalIp(): Promise<string>;
    findGateway(): Promise<Device>;
    close(): Promise<void>;
}
//# sourceMappingURL=index.d.ts.map