import { webcrypto as crypto } from 'crypto'; // remove when having crypto global
import { createRequire } from 'module';
import mergeOptions from 'merge-options';
import { defaultSocketOptions } from './default-socket-options.js';
const req = createRequire(import.meta.url);
const { name, version } = req('../../package.json');
const DEFAULT_SSDP_SIGNATURE = `node.js/${process.version.substring(1)} UPnP/1.1 ${name}/${version}`;
export function defaultSsdpOptions(options) {
    return mergeOptions(options ?? {}, {
        usn: `uuid:${crypto.randomUUID()}`,
        signature: DEFAULT_SSDP_SIGNATURE,
        sockets: [{}].map(defaultSocketOptions),
        retry: {
            times: 5,
            interval: 5000
        }
    });
}
//# sourceMappingURL=default-ssdp-options.js.map