/**
 * @packageDocumentation
 *
 * The libp2p keychain provides an API to store keys in a datastore in
 * an encrypted format.
 *
 * @example
 *
 * ```typescript
 * import { createLibp2p } from 'libp2p'
 * import { FsDatastore } from 'datastore-fs'
 *
 * const node = await createLibp2p({
 *   datastore: new FsDatastore('/path/to/dir')
 * })
 *
 * const info = await node.keychain.createKey('my-new-key', 'Ed25519')
 *
 * console.info(info) // { id: '...', name: 'my-new-key' }
 * ```
 */
export {};
//# sourceMappingURL=index.js.map