/**
 * When this error is thrown it means an operation was aborted,
 * usually in response to the `abort` event being emitted by an
 * AbortSignal.
 */
export declare class AbortError extends Error {
    readonly code: string;
    readonly type: string;
    constructor(message?: string);
    static readonly code = "ABORT_ERR";
    static readonly type = "aborted";
}
export declare class CodeError<T extends Record<string, any> = Record<string, never>> extends Error {
    readonly code: string;
    readonly props: T;
    constructor(message: string, code: string, props?: T);
}
//# sourceMappingURL=errors.d.ts.map