import type { PeerRouting } from './peer-routing/index.js';
import type { Startable } from '@libp2p/interfaces/startable';
import type { KadDHTComponents } from './index.js';
export interface QuerySelfInit {
    lan: boolean;
    peerRouting: PeerRouting;
    count?: number;
    interval?: number;
    queryTimeout?: number;
}
/**
 * Receives notifications of new peers joining the network that support the DHT protocol
 */
export declare class QuerySelf implements Startable {
    private readonly log;
    private readonly components;
    private readonly peerRouting;
    private readonly count;
    private readonly interval;
    private readonly queryTimeout;
    private running;
    private timeoutId?;
    private controller?;
    constructor(components: KadDHTComponents, init: QuerySelfInit);
    isStarted(): boolean;
    start(): Promise<void>;
    stop(): Promise<void>;
    _querySelf(): void;
}
//# sourceMappingURL=query-self.d.ts.map