import { Message } from '../../message/index.js';
import type { DHTMessageHandler } from '../index.js';
import type { PeerRouting } from '../../peer-routing/index.js';
import type { PeerId } from '@libp2p/interface-peer-id';
import type { AddressManager } from '@libp2p/interface-address-manager';
export interface FindNodeHandlerInit {
    peerRouting: PeerRouting;
    lan: boolean;
}
export interface FindNodeHandlerComponents {
    peerId: PeerId;
    addressManager: AddressManager;
}
export declare class FindNodeHandler implements DHTMessageHandler {
    private readonly peerRouting;
    private readonly lan;
    private readonly components;
    constructor(components: FindNodeHandlerComponents, init: FindNodeHandlerInit);
    /**
     * Process `FindNode` DHT messages
     */
    handle(peerId: PeerId, msg: Message): Promise<Message>;
}
//# sourceMappingURL=find-node.d.ts.map