import { Message } from '../../message/index.js';
import type { DHTMessageHandler } from '../index.js';
import type { Providers } from '../../providers.js';
import type { PeerRouting } from '../../peer-routing/index.js';
import type { PeerId } from '@libp2p/interface-peer-id';
import type { PeerInfo } from '@libp2p/interface-peer-info';
import type { PeerStore } from '@libp2p/interface-peer-store';
import type { Multiaddr } from '@multiformats/multiaddr';
export interface GetProvidersHandlerInit {
    peerRouting: PeerRouting;
    providers: Providers;
    lan: boolean;
}
export interface GetProvidersHandlerComponents {
    peerStore: PeerStore;
}
export declare class GetProvidersHandler implements DHTMessageHandler {
    private readonly components;
    private readonly peerRouting;
    private readonly providers;
    private readonly lan;
    constructor(components: GetProvidersHandlerComponents, init: GetProvidersHandlerInit);
    handle(peerId: PeerId, msg: Message): Promise<Message>;
    _getAddresses(peerId: PeerId): Promise<Multiaddr[]>;
    _getPeers(peerIds: PeerId[]): Promise<PeerInfo[]>;
}
//# sourceMappingURL=get-providers.d.ts.map