import type { Store } from './store.js';
import type { PeerStore, ProtoBook } from '@libp2p/interface-peer-store';
import type { PeerId } from '@libp2p/interface-peer-id';
export declare class PeerStoreProtoBook implements ProtoBook {
    private readonly dispatchEvent;
    private readonly store;
    /**
     * The ProtoBook is responsible for keeping the known supported
     * protocols of a peer
     */
    constructor(dispatchEvent: PeerStore['dispatchEvent'], store: Store);
    get(peerId: PeerId): Promise<string[]>;
    set(peerId: PeerId, protocols: string[]): Promise<void>;
    add(peerId: PeerId, protocols: string[]): Promise<void>;
    remove(peerId: PeerId, protocols: string[]): Promise<void>;
    delete(peerId: PeerId): Promise<void>;
}
//# sourceMappingURL=proto-book.d.ts.map