import type { PeerId } from '@libp2p/interface-peer-id';
import type { PubSubRPCMessage, SignedMessage } from '@libp2p/interface-pubsub';
export declare const SignPrefix: Uint8Array;
/**
 * Signs the provided message with the given `peerId`
 */
export declare function signMessage(peerId: PeerId, message: {
    from: PeerId;
    topic: string;
    data: Uint8Array;
    sequenceNumber: bigint;
}, encode: (rpc: PubSubRPCMessage) => Uint8Array): Promise<SignedMessage>;
/**
 * Verifies the signature of the given message
 */
export declare function verifySignature(message: SignedMessage, encode: (rpc: PubSubRPCMessage) => Uint8Array): Promise<boolean>;
/**
 * Returns the PublicKey associated with the given message.
 * If no valid PublicKey can be retrieved an error will be returned.
 */
export declare function messagePublicKey(message: SignedMessage): Promise<Uint8Array>;
//# sourceMappingURL=sign.d.ts.map