import { Record } from './record.js';
import type { Uint8ArrayList } from 'uint8arraylist';
export declare class Libp2pRecord {
    key: Uint8Array;
    value: Uint8Array;
    timeReceived: Date;
    constructor(key: Uint8Array, value: Uint8Array, timeReceived: Date);
    serialize(): Uint8Array;
    /**
     * Return the object format ready to be given to the protobuf library.
     */
    prepareSerialize(): Record;
    /**
     * Decode a protobuf encoded record
     */
    static deserialize(raw: Uint8Array | Uint8ArrayList): Libp2pRecord;
    /**
     * Create a record from the raw object returned from the protobuf library
     */
    static fromDeserialized(obj: Record): Libp2pRecord;
}
//# sourceMappingURL=index.d.ts.map