import type { MultiaddrConnection } from '@libp2p/interface-connection';
import type { Multiaddr } from '@multiformats/multiaddr';
import type { Duplex, Source } from 'it-stream-types';
import type { Uint8ArrayList } from 'uint8arraylist';
export interface Timeline {
    /**
     * Connection opening timestamp
     */
    open: number;
    /**
     * Connection upgraded timestamp
     */
    upgraded?: number;
    /**
     * Connection closed timestamp
     */
    close?: number;
}
export interface StreamOptions {
    signal?: AbortSignal;
}
export interface StreamProperties {
    stream: Duplex<AsyncIterable<Uint8ArrayList>, Source<Uint8ArrayList | Uint8Array>>;
    remoteAddr: Multiaddr;
    localAddr: Multiaddr;
}
/**
 * Convert a duplex iterable into a MultiaddrConnection.
 * https://github.com/libp2p/interface-transport#multiaddrconnection
 */
export declare function streamToMaConnection(props: StreamProperties, options?: StreamOptions): MultiaddrConnection;
//# sourceMappingURL=stream-to-ma-conn.d.ts.map