import type { DagJWS, EncodedJWS } from './signing.js';
import type { DagJWE, EncodedJWE } from './encryption.js';
import type { ByteView } from 'multiformats/codecs/interface';
export type { DagJWS, JWSSignature, EncodedJWS, EncodedSignature } from './signing.js';
export type { JWERecipient, DagJWE, EncodedRecipient, EncodedJWE } from './encryption.js';
export declare const name = "dag-jose";
export declare const code = 133;
export declare function toGeneral(jose: DagJWS | DagJWE | string): DagJWS | DagJWE;
export declare function encode(obj: DagJWS | DagJWE | string): ByteView<EncodedJWS | EncodedJWE>;
export declare function decode(data: ByteView<EncodedJWS | EncodedJWE>): DagJWS | DagJWE;
