import { CID } from 'multiformats/cid';
export interface JWSSignature {
    header?: Record<string, any>;
    protected?: string;
    signature: string;
}
export interface DagJWS {
    payload: string;
    signatures: Array<JWSSignature>;
    link?: CID;
}
export interface EncodedSignature {
    header?: Record<string, any>;
    protected?: Uint8Array;
    signature: Uint8Array;
}
export interface EncodedJWS {
    payload: Uint8Array;
    signatures: Array<EncodedSignature>;
}
export interface PublicKey {
    id: string;
    type: string;
    controller: string;
    publicKeyHex?: string;
    publicKeyBase64?: string;
}
export declare function fromSplit(split: Array<string>): DagJWS;
export declare function encode(jws: DagJWS): EncodedJWS;
export declare function decode(encoded: EncodedJWS): DagJWS;
