/**
 * Build fetch resource for request
 */
export declare function buildResource(serverResolver: string, hostname: string, recordType: string): string;
export interface DNSJSON {
    Question: Question[];
    Answer: Answer[];
}
interface Question {
    name: string;
    type: number;
}
interface Answer {
    name: string;
    type: number;
    data: string;
    TTL: number;
}
/**
 * Use fetch to find the record
 */
export declare function request(resource: string, signal: AbortSignal): Promise<DNSJSON>;
/**
 * Creates cache key composed by recordType and hostname
 *
 * @param {string} hostname
 * @param {string} recordType
 */
export declare function getCacheKey(hostname: string, recordType: string): string;
export {};
//# sourceMappingURL=utils.d.ts.map