/**
 * @typedef {import('multiformats').CID} CID
 */
export class Ledger {
    /**
     * @param {import('@libp2p/interface-peer-id').PeerId} peerId
     */
    constructor(peerId: import('@libp2p/interface-peer-id').PeerId);
    partner: import("@libp2p/interface-peer-id").PeerId;
    wantlist: Wantlist;
    exchangeCount: number;
    sentToPeer: Map<any, any>;
    accounting: {
        bytesSent: number;
        bytesRecv: number;
    };
    /**
     * @param {number} n
     */
    sentBytes(n: number): void;
    lastExchange: number | undefined;
    /**
     * @param {number} n
     */
    receivedBytes(n: number): void;
    /**
     *
     * @param {CID} cid
     * @param {number} priority
     * @param {import('../message/message').Message.Wantlist.WantType} wantType
     * @returns {void}
     */
    wants(cid: CID, priority: number, wantType: import('../message/message').Message.Wantlist.WantType): void;
    /**
     * @param {CID} cid
     * @returns {void}
     */
    cancelWant(cid: CID): void;
    /**
     * @param {CID} cid
     */
    wantlistContains(cid: CID): import("../wantlist/entry.js").WantListEntry | undefined;
    /**
     * @returns {number}
     */
    debtRatio(): number;
}
export type CID = import('multiformats').CID;
import { Wantlist } from "../wantlist/index.js";
//# sourceMappingURL=ledger.d.ts.map