/**
 * @typedef {import('@libp2p/interface-peer-id').PeerId} PeerId
 * @typedef {import('multiformats').CID} CID
 * @typedef {import('../network').Network} Network
 */
export class MsgQueue {
    /**
     * @param {PeerId} selfPeerId
     * @param {PeerId} otherPeerId
     * @param {Network} network
     */
    constructor(selfPeerId: PeerId, otherPeerId: PeerId, network: Network);
    peerId: import("@libp2p/interface-peer-id").PeerId;
    network: import("../network").Network;
    refcnt: number;
    /**
     * @private
     * @type {{cid:CID, priority:number, cancel?:boolean}[]}
     */
    private _entries;
    /** @private */
    private _log;
    sendEntries: (() => void) & {
        cancel: () => void;
        flush: () => void;
    };
    /**
     * @param {Message} msg
     */
    addMessage(msg: Message): void;
    /**
     * @param {{cid:CID, priority:number}[]} entries
     */
    addEntries(entries: {
        cid: CID;
        priority: number;
    }[]): void;
    /**
     * @private
     */
    private _sendEntries;
    /**
     * @param {Message} msg
     */
    send(msg: Message): Promise<void>;
}
export type PeerId = import('@libp2p/interface-peer-id').PeerId;
export type CID = import('multiformats').CID;
export type Network = import('../network').Network;
import { BitswapMessage as Message } from "../message/index.js";
//# sourceMappingURL=msg-queue.d.ts.map