/**
 * @typedef {import('ipfs-repo-migrations').ProgressCallback} MigrationProgressCallback
 */
/**
 * @param {(...args: any[]) => void} print
 * @param {import('ipfs-core-utils/multicodecs').Multicodecs} codecs
 * @param {object} options
 * @param {string} [options.path]
 * @param {boolean} [options.autoMigrate]
 * @param {MigrationProgressCallback} [options.onMigrationProgress]
 * @param {number} [options.peerStoreCacheSize]
 */
export function createRepo(print: (...args: any[]) => void, codecs: import('ipfs-core-utils/multicodecs').Multicodecs, options: {
    path?: string | undefined;
    autoMigrate?: boolean | undefined;
    onMigrationProgress?: import("ipfs-repo-migrations/dist/src/types").ProgressCallback | undefined;
    peerStoreCacheSize?: number | undefined;
}): import("ipfs-repo/dist/src/types").IPFSRepo;
export type MigrationProgressCallback = import('ipfs-repo-migrations').ProgressCallback;
//# sourceMappingURL=repo.browser.d.ts.map