export function parseChunkerString(chunker?: string | undefined): ChunkerOptions;
export function parseRabinString(chunker: string): RabinChunkerSettings;
export function parseChunkSize(str: string, name: string): number;
export type FixedChunkerOptions = {
    chunker: 'fixed';
    maxChunkSize?: number | undefined;
};
export type RabinChunkerOptions = {
    chunker: 'rabin';
    avgChunkSize: number;
    minChunkSize?: number | undefined;
    maxChunkSize?: number | undefined;
};
/**
 * Parses chunker string into options used by DAGBuilder in ipfs-unixfs-engine
 */
export type ChunkerOptions = FixedChunkerOptions | RabinChunkerOptions;
export type RabinChunkerSettings = {
    avgChunkSize: number;
    minChunkSize?: number | undefined;
    /**
     * Parses rabin chunker string
     */
    maxChunkSize?: number | undefined;
};
//# sourceMappingURL=utils.d.ts.map