/**
 * @typedef {import('multiformats/cid').Version} CIDVersion
 */
/**
 * @param {object} config
 * @param {import('ipfs-core-utils/multicodecs').Multicodecs} config.codecs
 * @param {import('ipfs-core-utils/multihashes').Multihashes} config.hashers
 * @param {import('ipfs-repo').IPFSRepo} config.repo
 * @param {import('../../types').Preload} config.preload
 *
 */
export function createPut({ codecs, hashers, repo, preload }: {
    codecs: import('ipfs-core-utils/multicodecs').Multicodecs;
    hashers: import('ipfs-core-utils/multihashes').Multihashes;
    repo: import('ipfs-repo').IPFSRepo;
    preload: import('../../types').Preload;
}): (block: Uint8Array, options?: import("ipfs-core-types/src/block").PutOptions | undefined) => Promise<CID<unknown, number, number, import("multiformats/cid").Version>>;
export type CIDVersion = import('multiformats/cid').Version;
//# sourceMappingURL=put.d.ts.map