export class DagAPI {
    /**
     * @param {object} config
     * @param {import('ipfs-core-utils/multihashes').Multihashes} config.hashers
     * @param {import('ipfs-core-utils/multicodecs').Multicodecs} config.codecs
     * @param {import('../../types').Preload} config.preload
     * @param {import('ipfs-repo').IPFSRepo} config.repo
     */
    constructor({ repo, codecs, hashers, preload }: {
        hashers: import('ipfs-core-utils/multihashes').Multihashes;
        codecs: import('ipfs-core-utils/multicodecs').Multicodecs;
        preload: import('../../types').Preload;
        repo: import('ipfs-repo').IPFSRepo;
    });
    export: (root: import("multiformats").CID<unknown, number, number, import("multiformats").Version>, options?: import("ipfs-core-types/src/dag/index.js").ExportOptions | undefined) => AsyncIterable<Uint8Array>;
    get: (cid: import("multiformats").CID<unknown, number, number, import("multiformats").Version>, options?: import("ipfs-core-types/src/dag/index.js").GetOptions | undefined) => Promise<import("ipfs-core-types/src/dag/index.js").GetResult>;
    import: (sources: AsyncIterable<Uint8Array> | Iterable<Uint8Array> | AsyncIterable<AsyncIterable<Uint8Array>> | Iterable<AsyncIterable<Uint8Array>>, options?: import("ipfs-core-types/src/dag/index.js").ImportOptions | undefined) => AsyncIterable<import("ipfs-core-types/src/dag/index.js").ImportResult>;
    resolve: (ipfsPath: import("ipfs-core-types/src/utils.js").IPFSPath, options?: import("ipfs-core-types/src/dag/index.js").ResolveOptions | undefined) => Promise<import("ipfs-core-types/src/dag/index.js").ResolveResult>;
    put: (node: any, options?: import("ipfs-core-types/src/dag/index.js").PutOptions | undefined) => Promise<import("multiformats").CID<unknown, number, number, import("multiformats").Version>>;
}
//# sourceMappingURL=index.d.ts.map