/**
 * @typedef {import('ipfs-unixfs').Mtime} Mtime
 * @typedef {import('multiformats/cid').Version} CIDVersion
 * @typedef {import('hamt-sharding').Bucket<any>} Bucket
 * @typedef {import('../').MfsContext} MfsContext
 * @typedef {import('@ipld/dag-pb').PBNode} PBNode
 * @typedef {import('@ipld/dag-pb').PBLink} PBLink
 */
/**
 * @param {MfsContext} context
 * @param {object} options
 * @param {CID} options.cid
 * @param {string} options.name
 * @param {number} options.size
 * @param {number} options.shardSplitThreshold
 * @param {string} options.hashAlg
 * @param {CIDVersion} options.cidVersion
 * @param {boolean} options.flush
 * @param {CID} [options.parentCid]
 * @param {PBNode} [options.parent]
 */
export function addLink(context: MfsContext, options: {
    cid: CID;
    name: string;
    size: number;
    shardSplitThreshold: number;
    hashAlg: string;
    cidVersion: CIDVersion;
    flush: boolean;
    parentCid?: CID<any, number, number, import("multiformats/cid").Version> | undefined;
    parent?: import("@ipld/dag-pb/dist/src/interface.js").PBNode | undefined;
}): Promise<import("./dir-sharded.js").ImportResult>;
export type Mtime = import('ipfs-unixfs').Mtime;
export type CIDVersion = import('multiformats/cid').Version;
export type Bucket = import('hamt-sharding').Bucket<any>;
export type MfsContext = import('../').MfsContext;
export type PBNode = import('@ipld/dag-pb').PBNode;
export type PBLink = import('@ipld/dag-pb').PBLink;
import { CID } from "multiformats/cid";
//# sourceMappingURL=add-link.d.ts.map