/**
 * @typedef {import('ipfs-unixfs').MtimeLike} MtimeLike
 * @typedef {import('multiformats/cid').Version} CIDVersion
 * @typedef {import('../').MfsContext} MfsContext
 */
/**
 * @param {MfsContext} context
 * @param {'file' | 'directory'} type
 * @param {object} options
 * @param {string} options.hashAlg
 * @param {CIDVersion} options.cidVersion
 * @param {boolean} options.flush
 * @param {MtimeLike} [options.mtime]
 * @param {number} [options.mode]
 */
export function createNode(context: MfsContext, type: 'file' | 'directory', options: {
    hashAlg: string;
    cidVersion: CIDVersion;
    flush: boolean;
    mtime?: import("ipfs-unixfs/dist/src/types").MtimeLike | undefined;
    mode?: number | undefined;
}): Promise<{
    cid: CID<unknown, 112, number, import("multiformats/cid").Version>;
    node: {
        Data: Uint8Array;
        Links: never[];
    };
}>;
export type MtimeLike = import('ipfs-unixfs').MtimeLike;
export type CIDVersion = import('multiformats/cid').Version;
export type MfsContext = import('../').MfsContext;
//# sourceMappingURL=create-node.d.ts.map