/**
 * @typedef {import('../').MfsContext} MfsContext
 * @typedef {import('multiformats/cid').Version} CIDVersion
 * @typedef {import('hamt-sharding').Bucket<any>} Bucket
 * @typedef {import('@ipld/dag-pb').PBNode} PBNode
 *
 * @typedef {object} RemoveLinkOptions
 * @property {string} name
 * @property {number} shardSplitThreshold
 * @property {string} hashAlg
 * @property {CIDVersion} cidVersion
 * @property {boolean} flush
 * @property {CID} [parentCid]
 * @property {PBNode} [parent]
 *
 * @typedef {object} RemoveLinkOptionsInternal
 * @property {string} name
 * @property {number} shardSplitThreshold
 * @property {string} hashAlg
 * @property {CIDVersion} cidVersion
 * @property {boolean} flush
 * @property {PBNode} parent
 */
/**
 * @param {MfsContext} context
 * @param {RemoveLinkOptions} options
 */
export function removeLink(context: MfsContext, options: RemoveLinkOptions): Promise<{
    node: import("@ipld/dag-pb/dist/src/interface.js").PBNode;
    cid: CID<unknown, 112, number, import("multiformats/cid").Version>;
}>;
export type MfsContext = import('../').MfsContext;
export type CIDVersion = import('multiformats/cid').Version;
export type Bucket = import('hamt-sharding').Bucket<any>;
export type PBNode = import('@ipld/dag-pb').PBNode;
export type RemoveLinkOptions = {
    name: string;
    shardSplitThreshold: number;
    hashAlg: string;
    cidVersion: CIDVersion;
    flush: boolean;
    parentCid?: CID<any, number, number, import("multiformats/cid").Version> | undefined;
    parent?: import("@ipld/dag-pb/dist/src/interface.js").PBNode | undefined;
};
export type RemoveLinkOptionsInternal = {
    name: string;
    shardSplitThreshold: number;
    hashAlg: string;
    cidVersion: CIDVersion;
    flush: boolean;
    parent: PBNode;
};
//# sourceMappingURL=remove-link.d.ts.map