/**
 * @typedef {import('../').MfsContext} MfsContext
 * @typedef {object} MfsTrail
 * @property {string} name
 * @property {import('multiformats/cid').CID} cid
 * @property {number} [size]
 * @property {string} [type]
 *
 * TODO: export supported types from unixfs-exporter and use for `type` above
 */
/**
 * @param {MfsContext} context
 * @param {string} path
 * @returns {Promise<MfsTrail[]>}
 */
export function toTrail(context: MfsContext, path: string): Promise<MfsTrail[]>;
export type MfsContext = import('../').MfsContext;
export type MfsTrail = {
    name: string;
    cid: import('multiformats/cid').CID;
    size?: number | undefined;
    /**
     * TODO: export supported types from unixfs-exporter and use for `type` above
     */
    type?: string | undefined;
};
//# sourceMappingURL=to-trail.d.ts.map