/**
 * @typedef {import('multiformats/cid').CID} CID
 * @typedef {import('multiformats/cid').Version} CIDVersion
 * @typedef {import('../').MfsContext} MfsContext
 * @typedef {import('./to-trail').MfsTrail} MfsTrail
 */
/**
 * Loop backwards through the trail, replacing links of all components to update CIDs
 *
 * @param {MfsContext} context
 * @param {MfsTrail[]} trail
 * @param {object} options
 * @param {number} options.shardSplitThreshold
 * @param {string} options.hashAlg
 * @param {CIDVersion} options.cidVersion
 * @param {boolean} options.flush
 */
export function updateTree(context: MfsContext, trail: MfsTrail[], options: {
    shardSplitThreshold: number;
    hashAlg: string;
    cidVersion: CIDVersion;
    flush: boolean;
}): Promise<any>;
export type CID = import('multiformats/cid').CID;
export type CIDVersion = import('multiformats/cid').Version;
export type MfsContext = import('../').MfsContext;
export type MfsTrail = import('./to-trail').MfsTrail;
//# sourceMappingURL=update-tree.d.ts.map