/**
 * @typedef {import('multiformats/hashes/interface').MultihashHasher} MultihashHasher
 * @typedef {import('ipfs-core-utils/multihashes').Multihashes} Multihashes
 */
export class RepoAPI {
    /**
     * @param {object} config
     * @param {import('ipfs-repo').IPFSRepo} config.repo
     * @param {Multihashes} config.hashers
     */
    constructor({ repo, hashers }: {
        repo: import('ipfs-repo').IPFSRepo;
        hashers: Multihashes;
    });
    gc: (options?: import("ipfs-core-types/src/repo/index.js").GCOptions | undefined) => AsyncIterable<import("ipfs-core-types/src/repo/index.js").GCResult>;
    stat: (options?: import("ipfs-core-types").AbortOptions | undefined) => Promise<import("ipfs-core-types/src/repo/index.js").StatResult>;
    version: (options?: import("ipfs-core-types").AbortOptions | undefined) => Promise<number>;
    /**
     * @param {string} addr
     */
    setApiAddr: (addr: string) => Promise<void>;
}
export type MultihashHasher = import('multiformats/hashes/interface').MultihashHasher;
export type Multihashes = import('ipfs-core-utils/multihashes').Multihashes;
//# sourceMappingURL=index.d.ts.map