/**
 * @typedef {AddAllContext & CatContext & GetContext & ListContext } Context
 * @typedef {import('./add-all').Context} AddAllContext
 * @typedef {import('./cat').Context} CatContext
 * @typedef {import('./get').Context} GetContext
 * @typedef {import('./ls').Context} ListContext
 */
export class RootAPI {
    /**
     * @param {Context} context
     */
    constructor({ preload, repo, hashers, options }: Context);
    addAll: (source: import("ipfs-core-types/src/utils.js").ImportCandidateStream, options?: (import("ipfs-core-types/src/root.js").AddAllOptions & import("ipfs-core-types").AbortOptions) | undefined) => AsyncIterable<import("ipfs-core-types/src/root.js").AddResult>;
    add: (entry: import("ipfs-core-types/src/utils.js").ImportCandidate, options?: import("ipfs-core-types/src/root.js").AddOptions | undefined) => Promise<import("ipfs-core-types/src/root.js").AddResult>;
    cat: (ipfsPath: import("ipfs-core-types/src/utils.js").IPFSPath, options?: import("ipfs-core-types/src/root.js").CatOptions | undefined) => AsyncIterable<Uint8Array>;
    get: (ipfsPath: import("ipfs-core-types/src/utils.js").IPFSPath, options?: import("ipfs-core-types/src/root.js").GetOptions | undefined) => AsyncIterable<Uint8Array>;
    ls: (ipfsPath: import("ipfs-core-types/src/utils.js").IPFSPath, options?: import("ipfs-core-types/src/root.js").ListOptions | undefined) => AsyncIterable<import("ipfs-core-types/src/root.js").IPFSEntry>;
}
export type Context = AddAllContext & CatContext & GetContext & ListContext;
export type AddAllContext = import('./add-all').Context;
export type CatContext = import('./cat').Context;
export type GetContext = import('./get').Context;
export type ListContext = import('./ls').Context;
//# sourceMappingURL=root.d.ts.map