/**
 * @typedef {import('@libp2p/interfaces').AbortOptions} AbortOptions
 */
export class OfflineDatastore {
    /**
     * @param {import('interface-datastore').Datastore} datastore
     */
    constructor(datastore: import('interface-datastore').Datastore);
    _datastore: import("interface-datastore").Datastore;
    /** @type {any[]} */
    stores: any[];
    /**
     * Put a value to the local datastore indexed by the received key properly encoded.
     *
     * @param {Uint8Array} key - identifier of the value.
     * @param {Uint8Array} value - value to be stored.
     * @param {AbortOptions} [options]
     */
    put(key: Uint8Array, value: Uint8Array, options?: import("@libp2p/interfaces").AbortOptions | undefined): Promise<void>;
    /**
     * Get a value from the local datastore indexed by the received key properly encoded.
     *
     * @param {Uint8Array} key - identifier of the value to be obtained.
     * @param {AbortOptions} [options]
     */
    get(key: Uint8Array, options?: import("@libp2p/interfaces").AbortOptions | undefined): Promise<Uint8Array>;
    /**
     * encode key properly - base32(/ipns/{cid})
     *
     * @param {Uint8Array} key
     */
    _routingKey(key: Uint8Array): Key;
}
export type AbortOptions = import('@libp2p/interfaces').AbortOptions;
import { Key } from "interface-datastore/key";
//# sourceMappingURL=offline-datastore.d.ts.map