/**
 * Error raised when there is lock already in place when repo is being opened.
 */
export class LockExistsError extends Error {
    code: string;
}
export namespace LockExistsError {
    const code: string;
}
/**
 * Error raised when requested item is not found.
 */
export class NotFoundError extends Error {
    code: string;
}
export namespace NotFoundError {
    const code_1: string;
    export { code_1 as code };
}
/**
 * Error raised when version of the stored repo is not compatible with version of this package.
 */
export class InvalidRepoVersionError extends Error {
    code: string;
}
export namespace InvalidRepoVersionError {
    const code_2: string;
    export { code_2 as code };
}
export const ERR_REPO_NOT_INITIALIZED: "ERR_REPO_NOT_INITIALIZED";
export const ERR_REPO_ALREADY_OPEN: "ERR_REPO_ALREADY_OPEN";
export const ERR_REPO_ALREADY_CLOSED: "ERR_REPO_ALREADY_CLOSED";
//# sourceMappingURL=errors.d.ts.map