/**
 * @typedef {import('interface-datastore').Query} Query
 * @typedef {import('interface-datastore').Datastore} Datastore
 * @typedef {import('interface-datastore').Options} DatastoreOptions
 * @typedef {import('interface-blockstore').Blockstore} Blockstore
 * @typedef {import('multiformats/cid').CID} CID
 * @typedef {import('./pin-manager').Pins} Pins
 */
/**
 * @param {Pins} pins
 * @param {Blockstore} store
 * @returns {Blockstore}
 */
export function createPinnedBlockstore(pins: Pins, store: Blockstore): Blockstore;
export type Query = import('interface-datastore').Query;
export type Datastore = import('interface-datastore').Datastore;
export type DatastoreOptions = import('interface-datastore').Options;
export type Blockstore = import('interface-blockstore').Blockstore;
export type CID = import('multiformats/cid').CID;
export type Pins = import('./pin-manager').Pins;
//# sourceMappingURL=pinned-blockstore.d.ts.map