/**
 * Transform a cid to the appropriate datastore key.
 *
 * @param {CID} c
 */
export function cidToKey(c: CID): Key;
/**
 * Transform a datastore Key instance to a CID
 * As Key is a multihash of the CID, it is reconstructed using IPLD's RAW codec.
 * Hence it is highly probable that stored CID will differ from a CID retrieved from blockstore.
 *
 * @param {Key} key
 */
export function keyToCid(key: Key): CID<unknown, 85, number, 1>;
/**
 * @param {Key | string} key
 */
export function keyToMultihash(key: Key | string): import("multiformats").MultihashDigest<number>;
import { CID } from "multiformats";
import { Key } from "interface-datastore/key";
//# sourceMappingURL=blockstore.d.ts.map