/**
 * @typedef {import('multiformats/cid').CID} CID
 * @typedef {import('interface-blockstore').Blockstore} Blockstore
 * @typedef {import('../types').loadCodec} loadCodec
 * @typedef {import('../types').AbortOptions} AbortOptions
 */
/**
 * @param {CID} cid
 * @param {Blockstore} blockstore
 * @param {loadCodec} loadCodec
 * @param {AbortOptions} [options]
 * @returns {AsyncGenerator<CID, void, undefined>}
 */
export function walkDag(cid: CID, blockstore: Blockstore, loadCodec: loadCodec, options?: import("../types").AbortOptions | undefined): AsyncGenerator<CID, void, undefined>;
export type CID = import('multiformats/cid').CID;
export type Blockstore = import('interface-blockstore').Blockstore;
export type loadCodec = import('../types').loadCodec;
export type AbortOptions = import('../types').AbortOptions;
//# sourceMappingURL=walk-dag.d.ts.map