/// <reference types="ws" />
import type WebSocket from './web-socket.js';
import type { SinkOptions } from './sink.js';
import type { Duplex } from 'it-stream-types';
export interface DuplexWebSocket extends Duplex<Uint8Array, Uint8Array, Promise<void>> {
    connected: () => Promise<void>;
    localAddress?: string;
    localPort?: number;
    remoteAddress: string;
    remotePort: number;
    close: () => Promise<void>;
    destroy: () => void;
    socket: WebSocket;
}
export interface DuplexWebSocketOptions extends SinkOptions {
    remoteAddress?: string;
    remotePort?: number;
}
declare const _default: (socket: WebSocket, options?: DuplexWebSocketOptions) => DuplexWebSocket;
export default _default;
//# sourceMappingURL=duplex.d.ts.map